<?php

define( 'KSTATS_TABLE_OLD', $wpdb->prefix . 'statpress_old' );

add_action( 'init', 'kstats_cleanup_make_totals' );

function kstats_cleanup_make_totals() {
	global $wpdb, $kstatstime;

	$kstatstime->start_timer();

	$wpdb->query( "ALTER TABLE `" . KSTATS_TABLE_OLD . "` DROP `date`, DROP `time`, DROP `threat_score`, DROP `threat_type`, DROP `nation`" );
	$wpdb->query( "ALTER TABLE `" . KSTATS_TABLE_OLD . "` CHANGE `id` `id` INT UNSIGNED NOT NULL AUTO_INCREMENT" );
	$wpdb->query( "ALTER TABLE `" . KSTATS_TABLE_OLD . "` CHANGE `timestamp` `timestamp_` TINYTEXT CHARACTER SET utf8 COLLATE utf8_bin NULL DEFAULT NULL" );
	$wpdb->query( "ALTER TABLE `" . KSTATS_TABLE_OLD . "` CHANGE `searchengine` `search_engine` TINYTEXT CHARACTER SET utf8 COLLATE utf8_bin NULL DEFAULT NULL" );
	$wpdb->query( "ALTER TABLE `" . KSTATS_TABLE_OLD . "` CHANGE `search` `search_terms` TEXT CHARACTER SET utf8 COLLATE utf8_bin NULL DEFAULT NULL" );
	$wpdb->query( "ALTER TABLE `" . KSTATS_TABLE_OLD . "` CHANGE `urlrequested` `url` TEXT CHARACTER SET utf8 COLLATE utf8_bin NULL DEFAULT NULL , CHANGE `agent` `user_agent` TEXT CHARACTER SET latin1 COLLATE latin1_swedish_ci NULL DEFAULT NULL" );
	$wpdb->query( "ALTER TABLE `" . KSTATS_TABLE_OLD . "` ADD `timestamp` DATETIME NOT NULL AFTER `id` , ADD INDEX ( timestamp )" );
	$wpdb->query( "UPDATE `" . KSTATS_TABLE_OLD . "` SET timestamp = FROM_UNIXTIME(timestamp_)" );
	$wpdb->query( "ALTER TABLE `" . KSTATS_TABLE_OLD . "` DROP `timestamp_`" );
	$wpdb->query( "ALTER TABLE `" . KSTATS_TABLE_OLD . "` ADD `preserved` TINYINT( 1 ) NULL DEFAULT NULL" );

	// Grab Totals
	$query[] = sprintf( "SELECT COUNT( DISTINCT ip ) AS visitors, COUNT( timestamp ) AS pageviews FROM `%s` WHERE feed = '' AND spider = ''", KSTATS_TABLE_OLD );
	$result = $wpdb->get_row( end( $query ) );

	$total['visitors']['total']  = $result->visitors;
	$total['pageviews']['total'] = $result->pageviews;

	$query[] = sprintf( "SELECT COUNT( ip ) AS total FROM `%s` WHERE spider <> ''", KSTATS_TABLE_OLD );
	$total['spiders']['total'] = $wpdb->get_row( end( $query ) )->total;

	$query[] = sprintf( "SELECT COUNT( ip ) AS total FROM `%s` WHERE feed <> ''", KSTATS_TABLE_OLD );
	$total['feeds']['total'] = $wpdb->get_row( end( $query ) )->total;


	// Grab Last Month
	$query[] = sprintf( "SELECT COUNT( DISTINCT ip ) AS visitors, COUNT( timestamp ) AS pageviews FROM `%s` WHERE feed = '' AND spider = '' AND SUBSTR(timestamp, 1, 7) = '%s'", KSTATS_TABLE_OLD, $kstatstime->last_month );
	$result = $wpdb->get_row( end( $query ) );

	$total['visitors']['last_month']  = $result->visitors;
	$total['pageviews']['last_month'] = $result->pageviews;

	$query[] = sprintf( "SELECT COUNT( ip ) AS total FROM `%s` WHERE spider <> '' AND SUBSTR(timestamp, 1, 7) = '%s'", KSTATS_TABLE_OLD, $kstatstime->last_month );
	$total['spiders']['last_month'] = $wpdb->get_row( end( $query ) )->total;

	$query[] = sprintf( "SELECT COUNT( ip ) AS total FROM `%s` WHERE feed <> '' AND SUBSTR(timestamp, 1, 7) = '%s'", KSTATS_TABLE_OLD, $kstatstime->last_month );
	$total['feeds']['last_month'] = $wpdb->get_row( end( $query ) )->total;


	// Grab This Month
	$query[] = sprintf( "SELECT COUNT( DISTINCT ip ) AS visitors, COUNT( timestamp ) AS pageviews FROM `%s` WHERE feed = '' AND spider = '' AND SUBSTR(timestamp, 1, 7) = '%s'", KSTATS_TABLE_OLD, $kstatstime->this_month );
	$result = $wpdb->get_row( end( $query ) );

	$total['visitors']['this_month']  = $result->visitors;
	$total['pageviews']['this_month'] = $result->pageviews;

	$query[] = sprintf( "SELECT COUNT( ip ) AS total FROM `%s` WHERE spider <> '' AND SUBSTR(timestamp, 1, 7) = '%s'", KSTATS_TABLE_OLD, $kstatstime->this_month );
	$total['spiders']['this_month'] = $wpdb->get_row( end( $query ) )->total;

	$query[] = sprintf( "SELECT COUNT( ip ) AS total FROM `%s` WHERE feed <> '' AND SUBSTR(timestamp, 1, 7) = '%s'", KSTATS_TABLE_OLD, $kstatstime->this_month );
	$total['feeds']['this_month'] = $wpdb->get_row( end( $query ) )->total;


	// Last 21 days
	$query[] = sprintf( "SELECT SUBSTR( timestamp, 1, 10 ) AS timestamp, COUNT(  DISTINCT ip ) AS visitors, COUNT(  timestamp ) AS pageviews FROM `%s` WHERE feed = '' AND spider = '' AND SUBSTR( timestamp, 1, 10 ) >= '%s' GROUP BY SUBSTR( timestamp, 1, 10 )", KSTATS_TABLE_OLD, $kstatstime->last_21[21] );
	$one = $wpdb->get_results( end( $query ), ARRAY_A );

	$query[] = sprintf( "SELECT SUBSTR( timestamp, 1, 10 ) AS timestamp, COUNT(  ip ) AS spiders FROM `%s` WHERE spider <> '' AND SUBSTR( timestamp, 1, 10 ) >= '%s' GROUP BY SUBSTR( timestamp, 1, 10 )", KSTATS_TABLE_OLD, $kstatstime->last_21[21] );
	$two = $wpdb->get_results( end( $query ), ARRAY_A );
	
	$query[] = sprintf( "SELECT SUBSTR( timestamp, 1, 10 ) AS timestamp, COUNT(  ip ) AS feeds FROM `%s` WHERE feed <> '' AND SUBSTR( timestamp, 1, 10 ) >= '%s' GROUP BY SUBSTR( timestamp, 1, 10 )", KSTATS_TABLE_OLD, $kstatstime->last_21[21] );
	$three = $wpdb->get_results( end( $query ), ARRAY_A );

	$rows = count( $one ) - 1; echo '<br />';

	for ( $i = 0; $i <= $rows; $i++ ) {
		$total[$one[$i]['timestamp']]['total'] = $one[$i]['visitors'];
		$total[$one[$i]['timestamp']]['last_month'] = $one[$i]['pageviews'];
		$total[$one[$i]['timestamp']]['this_month'] = $two[$i]['spiders'];
		$total[$one[$i]['timestamp']]['yesterday'] = $three[$i]['feeds'];
	}

	$total['visitors']['yesterday']  = $total[$kstatstime->yesterday]['total'];
	$total['pageviews']['yesterday'] = $total[$kstatstime->yesterday]['last_month'];
	$total['spiders']['yesterday']   = $total[$kstatstime->yesterday]['this_month'];
	$total['feeds']['yesterday']     = $total[$kstatstime->yesterday]['yesterday'];

	$wpdb->query( "TRUNCATE TABLE `" . KSTATS_TABLE_TOTALS . "`" );

	$build_query = array();

	foreach ( $total as $name => $data ) {
		$type = ( preg_match( '~[0-9]{4}-[0-9]{2}-[0-9]{2}~', $name ) ) ? 'charts' : 'totals';
		$build_query[] = sprintf( "('%s', '%s', '%d', '%d', '%d', '%d')", $type, $name, $data['total'], $data['last_month'], $data['this_month'], $data['yesterday'] );
	}

	$query[] = sprintf( "INSERT INTO `%s` VALUES %s", KSTATS_TABLE_TOTALS, implode( ', ', $build_query ) );
	$wpdb->query( end( $query ) );

	$wpdb->query( "TRUNCATE TABLE " . KSTATS_TABLE_REFERRERS );
	$wpdb->query( "TRUNCATE TABLE " . KSTATS_TABLE_SEARCHES );
	$wpdb->query( "TRUNCATE TABLE " . KSTATS_TABLE_AGENTS );
	$wpdb->query( "TRUNCATE TABLE " . KSTATS_TABLE_SPIDERS );

	kstats_cleanup_referrers( KSTATS_TABLE_OLD );
	kstats_cleanup_search_terms( KSTATS_TABLE_OLD );
	kstats_cleanup_agents( KSTATS_TABLE_OLD );
	kstats_cleanup_spiders( KSTATS_TABLE_OLD );

	$result = $wpdb->get_row( "SELECT COUNT( ip ) AS total FROM `" . KSTATS_TABLE_OLD . "` WHERE SUBSTR(timestamp, 1, 10) = '" . $datetime['today'] . "'" );
	$limit = $result->total;

	$result = $wpdb->query( "SHOW TABLE STATUS LIKE '" . KSTATS_TABLE_OLD . "'" );
	$auto_inc = $result->Auto_increment;

	$query[] = sprintf( "DROP TABLE IF EXISTS `%s`", KSTATS_TABLE_RAW );
	$wpdb->query( end( $query ) );

	$query[] = sprintf( "CREATE TABLE IF NOT EXISTS `%s` (
						  `id` int UNSIGNED NOT NULL AUTO_INCREMENT,
						  `timestamp` datetime NOT NULL,
						  `ip` tinytext CHARACTER SET latin1,
						  `url` text CHARACTER SET latin1,
						  `user_agent` text CHARACTER SET latin1,
						  `referrer` text CHARACTER SET latin1,
						  `spider` tinytext CHARACTER SET latin1,
						  `search_engine` tinytext CHARACTER SET latin1,
						  `search_terms` text CHARACTER SET latin1,
						  `os` tinytext CHARACTER SET latin1,
						  `browser` tinytext CHARACTER SET latin1,
						  `feed` tinytext CHARACTER SET latin1,
						  `user` tinytext CHARACTER SET latin1,
						  `preserved` tinyint(1) DEFAULT NULL,
						  UNIQUE KEY `id` (`id`),
						  KEY `timestamp` (`timestamp`)
					    ) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT = %d", KSTATS_TABLE_RAW, $auto_inc );
	$wpdb->query( end( $query ) );

	$query[] = sprintf( "INSERT INTO `%s` SELECT id, timestamp, ip, url, user_agent, referrer, spider, search_engine, search_terms, os, browser, feed, user, preserved FROM `%s` ORDER BY timestamp DESC LIMIT 30", KSTATS_TABLE_RAW, KSTATS_TABLE_OLD );
	$wpdb->query( end( $query ) );

	$query[] = sprintf( "UPDATE `%s` SET preserved = 1", KSTATS_TABLE_RAW );
	$wpdb->query( end( $query ) );

	$wpdb->query( "DROP TABLE `" . KSTATS_TABLE_OLD . "`" );

	update_option( 'kstats_last_run', $kstatstime->today );

	$kstatstime->end_timer();
	die;
}

